<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">

<html lang="en">
<head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

<meta name="generator" content="PHPDoctor 2RC4 (http://peej.github.com/phpdoctor/)">
<meta name="when" content="Fri, 15 Apr 2011 16:43:06 +0000">

<link rel="stylesheet" type="text/css" href="../../stylesheet.css">
<link rel="start" href="../../overview-summary.html">

<title>classes/methodDoc.php (PHPDoctor)</title>

</head>
<body id="file" onload="parent.document.title=document.title;">

<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/classes/methoddoc.php.html" target="_top">No frames</a>
</div>
<hr>

<h1>classes/methodDoc.php</h1>
<hr>

<a name="line1"></a><pre><?php
<a name="line2"></a>/*
<a name="line3"></a>PHPDoctor: The PHP Documentation Creator
<a name="line4"></a>Copyright (C) 2004 Paul James <paul@peej.co.uk>
<a name="line5"></a>
<a name="line6"></a>This program is free software; you can redistribute it and/or modify
<a name="line7"></a>it under the terms of the GNU General Public License as published by
<a name="line8"></a>the Free Software Foundation; either version 2 of the License, or
<a name="line9"></a>(at your option) any later version.
<a name="line10"></a>
<a name="line11"></a>This program is distributed in the hope that it will be useful,
<a name="line12"></a>but WITHOUT ANY WARRANTY; without even the implied warranty of
<a name="line13"></a>MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
<a name="line14"></a>GNU General Public License for more details.
<a name="line15"></a>
<a name="line16"></a>You should have received a copy of the GNU General Public License
<a name="line17"></a>along with this program; if not, write to the Free Software
<a name="line18"></a>Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<a name="line19"></a>*/
<a name="line20"></a>
<a name="line21"></a>/** Represents a PHP function or method (member function).
<a name="line22"></a> *
<a name="line23"></a> * @package PHPDoctor
<a name="line24"></a> */
<a name="line25"></a>class MethodDoc extends ExecutableDoc
<a name="line26"></a>{
<a name="line27"></a>
<a name="line28"></a>	/** The type of variable this method returns.
<a name="line29"></a>	 *
<a name="line30"></a>	 * @var type
<a name="line31"></a>	 */
<a name="line32"></a>	var $_returnType;
<a name="line33"></a>
<a name="line34"></a>	/** Is this class abstract.
<a name="line35"></a>	 *
<a name="line36"></a>	 * @var bool
<a name="line37"></a>	 */
<a name="line38"></a>	var $_abstract = FALSE;
<a name="line39"></a>
<a name="line40"></a>	/** Constructor
<a name="line41"></a>	 *
<a name="line42"></a>	 * @param str name Name of this element
<a name="line43"></a>	 * @param ClassDoc|MethodDoc parent The parent of this element
<a name="line44"></a>	 * @param RootDoc root The root element
<a name="line45"></a>	 * @param str filename The filename of the source file this element is in
<a name="line46"></a>	 * @param int lineNumber The line number of the source file this element is at
<a name="line47"></a>	 * @param str sourcePath The source path containing the source file
<a name="line48"></a>	 */
<a name="line49"></a>	function methodDoc($name, &$parent, &$root, $filename, $lineNumber, $sourcePath)
<a name="line50"></a>    {
<a name="line51"></a>		$this->_name = $name;
<a name="line52"></a>		$this->_parent =& $parent; // set reference to parent
<a name="line53"></a>		$this->_root =& $root; // set reference to root
<a name="line54"></a>		$this->_returnType =& new type('void', $root);
<a name="line55"></a>		$this->_filename = $filename;
<a name="line56"></a>		$this->_lineNumber = $lineNumber;
<a name="line57"></a>		$this->_sourcePath = $sourcePath;
<a name="line58"></a>	}
<a name="line59"></a>
<a name="line60"></a>	/** Add a parameter to this method.
<a name="line61"></a>	 *
<a name="line62"></a>	 * @param FieldDoc parameter
<a name="line63"></a>	 */
<a name="line64"></a>	function addParameter(&$parameter)
<a name="line65"></a>    {
<a name="line66"></a>		$this->_parameters[$parameter->name()] =& $parameter;
<a name="line67"></a>	}
<a name="line68"></a>
<a name="line69"></a>	/** Get return type.
<a name="line70"></a>	 *
<a name="line71"></a>	 * @return Type
<a name="line72"></a>	 */
<a name="line73"></a>	function returnType()
<a name="line74"></a>    {
<a name="line75"></a>		return $this->_returnType;
<a name="line76"></a>	}
<a name="line77"></a>	
<a name="line78"></a>	/** Format a return type for outputting. Recognised types are turned into
<a name="line79"></a>	 * HTML anchor tags to the documentation page for the class defining them.
<a name="line80"></a>	 *
<a name="line81"></a>	 * @return str The string representation of the return type
<a name="line82"></a>	 */
<a name="line83"></a>	function returnTypeAsString()
<a name="line84"></a>    {
<a name="line85"></a>		$myPackage =& $this->containingPackage();
<a name="line86"></a>		$classDoc =& $this->_returnType->asClassDoc();
<a name="line87"></a>		if ($classDoc) {
<a name="line88"></a>			$packageDoc =& $classDoc->containingPackage();
<a name="line89"></a>            return '<a href="'.str_repeat('../', $myPackage->depth() + 1).$classDoc->asPath().'">'.$classDoc->name().$this->_returnType->dimension().'</a>';
<a name="line90"></a>		} else {
<a name="line91"></a>			return $this->_returnType->typeName().$this->_returnType->dimension();
<a name="line92"></a>		}
<a name="line93"></a>	}
<a name="line94"></a>
<a name="line95"></a>	/** Is this construct a function.
<a name="line96"></a>	 *
<a name="line97"></a>	 * @return bool
<a name="line98"></a>	 */
<a name="line99"></a>	function isFunction()
<a name="line100"></a>    {
<a name="line101"></a>		if (strtolower(get_class($this->_parent)) == 'rootdoc' && !$this->containingClass()) {
<a name="line102"></a>			return TRUE;
<a name="line103"></a>		} else {
<a name="line104"></a>			return FALSE;
<a name="line105"></a>		}
<a name="line106"></a>	}
<a name="line107"></a>	
<a name="line108"></a>	/** Is this construct a method.
<a name="line109"></a>	 *
<a name="line110"></a>	 * @return bool
<a name="line111"></a>	 */
<a name="line112"></a>	function isMethod()
<a name="line113"></a>    {
<a name="line114"></a>		return !$this->isFunction();
<a name="line115"></a>	}
<a name="line116"></a>
<a name="line117"></a>	/** Return true if this class is abstract.
<a name="line118"></a>	 *
<a name="line119"></a>	 * @return bool
<a name="line120"></a>	 */
<a name="line121"></a>	function isAbstract()
<a name="line122"></a>    {
<a name="line123"></a>		return $this->_abstract;
<a name="line124"></a>	}
<a name="line125"></a>
<a name="line126"></a>}
<a name="line127"></a>
<a name="line128"></a>?>
<a name="line129"></a></pre>
<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/classes/methoddoc.php.html" target="_top">No frames</a>
</div>
<hr>

<p id="footer">This document was generated by <a href="http://peej.github.com/phpdoctor/">PHPDoctor: The PHP Documentation Creator</a></p>

</body>

</html>